import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class ComplexMuller extends Frame
{  public int Iter; public double Err;
   public ComplexMuller()
   {  setSize(800,500);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   public Complex fn(Complex X)
   {  return ((X.mult(X)).add(X)).add(1.0);  // X ^ 2 + X +1@ɉׂ
   }
   public Complex solution(double EPS, Complex Init1, Complex Init2, Complex Init3,int IterMax)
   {  Complex X1, X2, X3, F1, F2, F3, DX1, DX2, DX3, DF1, DF2;
      Complex A, B, C, XX, YY; Root R =new Root(new Complex(0,0),new Complex(0,0));
      Iter = 0;  // l
      X1  = Init1     ; X2  = Init2     ; X3 = Init3;
      F1  = fn(X1)    ; F2  = fn(X2)    ; F3 = fn(X3);
      DX1 = X1.sub(X2); DX2 = X2.sub(X3); DX3 = X3.sub(X1);
      DF1 = F1.sub(F2); DF2 = F2.sub(F3);
      while(Iter < IterMax)
      { Iter++;  Err = F3.abs(); if(Err < EPS) break;
        // A A=((F2-F3)*(X1-X2)-(F1-F2)*(X2-X3))/((X1-X2)*(X2-X3)*(X3-X1))
        //                  B=(F1-F2)/(X1-X2)-A*(X1+X2)   C=F1-B*X1-A*X1*X1
        XX  = (DF2.mult(DX1)).sub(DF1.mult(DX2));
        YY  = (DX1.mult(DX2)).mult(DX3);
        A   = XX.div(YY);
        B   = (DF1.div(DX1)).sub(A.mult(X1.add(X2)));
        C   = (F1.sub(B.mult(X1))).sub(A.mult(X1.mult(X1)));
        R   = new Root(A, B, C);
        X1  = X2; X2 = X3; F1  = F2; F2 =F3;
        DX1 = DX2; DX2 = DX3; DF1 = DF2;
        double E1  = ((R.R1).sub(X3)).abs(); double E2 = ((R.R2).sub(X3)).abs();
        if(E1 <= E2) X3 = R.R1; else X3 = R.R2;
        F3  = fn(X3);
        
        DX3 = X3.sub(X1); DF2 = F2.sub(F3);
      }
      return X3;
   }
   public void paint(Graphics g)
   {  setTitle("~[@");
      Complex R = solution(0.0001, new Complex(0, 0), new Complex(1,0),new Complex(2, 0), 30);
      g.drawString( " "+ R.ToString() +" (JԂ = "+ Iter + ", 덷 = " + Err +")" ,20,50);
   } 
   public static void main(String[] args)
   {  Frame w = new ComplexMuller();
      w.setVisible(true);
   }
}
